"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var _ = require("lodash");
var DcTablePagingPipe = (function () {
    function DcTablePagingPipe() {
    }
    DcTablePagingPipe.prototype.transform = function (value, filter, sort, limit, page) {
        filter = filter || null;
        sort = sort || null;
        limit = limit || 5;
        page = page || 1;
        value = _.cloneDeep(value);
        var result = [];
        if (value) {
            if (sort && sort.value) {
                value.sort(function (a, b) {
                    var res = sort.value === 'asc' ? a[sort.key] > b[sort.key] : b[sort.key] > a[sort.key];
                    return res ? 1 : 0;
                });
            }
            if (filter && filter.key) {
                var keys = (filter.key && _.split(filter.key, ',')) || [];
                var values = (filter.value && _.split(filter.value, ',')) || [];
                var matchs = (filter.match && _.split(filter.match, ',')) || [];
                if (keys.length > 0) {
                    for (var j = 0; j < value.length; j++) {
                        var list = value[j];
                        var flag = true;
                        for (var i = 0; i < keys.length; i++) {
                            if (matchs[i] && matchs[i] == 'full') {
                                if (list[keys[i]] != list[values[i]]) {
                                    flag = false;
                                    break;
                                }
                            }
                            else {
                                if (list[keys[i]].indexOf(values[i]) === -1) {
                                    flag = false;
                                    break;
                                }
                            }
                        }
                        if (flag) {
                            result.push(list);
                        }
                    }
                    /*result = _.filter(value, (list) => {
                                let flag = true;
                                for (let i = 0; i < keys.length; i++) {
                                  if (matchs[i] && matchs[i] == 'full') {
                                    if (list[keys[i]] != list[values[i]]) {
                                      flag = false;
                                      break;
                                    }
                                  } else {
                                    if (list[keys[i]].indexOf(values[i] === -1)){
                                      flag = false;
                                      break;
                                    }
                                  }
                                }
                                if (flag) {
                                  return list;
                                }
                              });*/
                }
            }
            else {
                result = value;
            }
        }
        var start = (page - 1) * limit;
        var end = limit;
        if (result[start] !== undefined) {
            if (result[start + end] !== undefined) {
                result = result.slice(start, start + end);
            }
            else {
                result = result.slice(start);
            }
        }
        else {
            result = [];
        }
        return result;
    };
    DcTablePagingPipe.decorators = [
        { type: core_1.Pipe, args: [{ name: 'dcTablePaging' },] },
    ];
    /** @nocollapse */
    DcTablePagingPipe.ctorParameters = function () { return []; };
    return DcTablePagingPipe;
}());
exports.DcTablePagingPipe = DcTablePagingPipe;
//# sourceMappingURL=table.paging.pipe.js.map